Loading...
Searching...
No Matches
ParmList Class Reference

Parameter template list that is always terminated. More...

`#include <openvdb_houdini/ParmFactory.h>`

## Public Types

using | PrmTemplateVec = std::vector<PRM_Template>

## Public Member Functions

| ParmList ()
bool | empty () const
| Return `true` if this list contains no parameters.
size_t | size () const
| Return the number of parameters in this list.
void | clear ()
| Remove all parameters from this list.
ParmList & | beginSwitcher (const std::string &token, const std::string &label="")
| Begin a collection of tabs.
ParmList & | beginExclusiveSwitcher (const std::string &token, const std::string &label="")
| Begin an exclusive collection of tabs. Only one tab is "active" at a time.
ParmList & | endSwitcher ()
| End a collection of tabs.
ParmList & | addFolder (const std::string &label)
| Add a tab with the given label to the current tab collection.
PRM_Template * | get () const
| Return a heap-allocated copy of this list's array of parameters.
ParmList & | add (const PRM_Template &)
| Add a parameter to this list.
ParmList & | add (const ParmFactory &)
| Add a parameter to this list.

## Detailed Description

Parameter template list that is always terminated.

## Member Typedef Documentation

## PrmTemplateVec

using PrmTemplateVec = std::vector<PRM_Template>

## Constructor & Destructor Documentation

## ParmList()

ParmList | ( |  | ) |

inline

## Member Function Documentation

## add() [1/2]

ParmList & add | ( | const ParmFactory & |  | ) |

Add a parameter to this list.

## add() [2/2]

ParmList & add | ( | const PRM_Template & |  | ) |

Add a parameter to this list.

## addFolder()

ParmList & addFolder | ( | const std::string & | label | ) |

Add a tab with the given label to the current tab collection.

Parameters subsequently added to this ParmList until the next addFolder() or endSwitcher() call will be displayed on the tab.

Exceptions

  std::runtime_error | if not inside a switcher

## beginExclusiveSwitcher()

ParmList & beginExclusiveSwitcher | ( | const std::string & | token,
|  | const std::string & | label = "" )

Begin an exclusive collection of tabs. Only one tab is "active" at a time.

Tabs may be nested.

## beginSwitcher()

ParmList & beginSwitcher | ( | const std::string & | token,
|  | const std::string & | label = "" )

Begin a collection of tabs.

Tabs may be nested.

## clear()

void clear | ( |  | ) |

inline

Remove all parameters from this list.

## empty()

bool empty | ( |  | ) | const

inline

Return `true` if this list contains no parameters.

## endSwitcher()

ParmList & endSwitcher | ( |  | ) |

End a collection of tabs.

Exceptions

  std::runtime_error | if not inside a switcher or if no tabs were added to the switcher

## get()

PRM_Template * get | ( |  | ) | const

Return a heap-allocated copy of this list's array of parameters.

## size()

size_t size | ( |  | ) | const

inline

Return the number of parameters in this list.

Note
  Some parameter types have parameter lists of their own. Those nested lists are not included in this count.